package com.nisum;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.fail;

import org.junit.jupiter.api.*;

public class CalculatorTest {
    final int MIN = 5, MAX = 20;
    int num1, num2;
    
     public int randInt() {
         return (int) ((Math.random() * (MAX - MIN)) + MIN);
     }
     
     @BeforeAll
     static void printStarting() {
         System.out.println("The testing of the Calculator class has commenced!!");
     }

    @AfterAll
    static void printFinished() {
        System.out.println("The testing of the Calculator class has ceased!!");
    }
    
    @BeforeEach
    public void setRandomNums() {
        num1 = randInt();
        num2 = randInt();
    }
    
    @Test
    public void testAdd() {
         int sum = Calculator.add(num1, num2);
         String errorMessage = String.format("%x + %x should equal %x", num1, num2, sum);
         assertEquals(num1 + num2, sum, errorMessage);
    }
    
    @Disabled
    @Test
    public void disabledTest() {
        fail("This test should not run");
    }
    
    @RepeatedTest(value = 10, name = "Subtraction test {currentRepetition} of {totalRepetitions}")
    public void testSubtract() {
        int diff = Calculator.subtract(num1, num2);
        String errorMessage = String.format("%x - %x should equal %x", num1, num2, diff);
        assertEquals(num1 - num2, diff, errorMessage);
    }
}
