package com.nisum;

import static org.junit.jupiter.api.Assertions.assertEquals;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

public class ParameterizedPrimesTest {
    
    @ParameterizedTest
    @CsvSource(value = {"2:true", "6:false", "22:false", "23:true"}, delimiter = ':')
    void testPrimes(String possiblePrimeStr, String booleanStr) {
        int possiblePrime = Integer.parseInt(possiblePrimeStr);
        boolean isPrimeOrNah = Boolean.parseBoolean(booleanStr);
        
        String errorMessage = String.format("%s is %s a prime number.", possiblePrime, (isPrimeOrNah ? "" : " NOT "));
        
        assertEquals(Primes.isPrime(possiblePrime), isPrimeOrNah, errorMessage);
    }
    
}
